#ifndef SETTINGS_H
#define SETTINGS_H

#define debuglog        false
#define debugprint      true

#ifndef LOGLIB

#define LOGLIB          "/LIB/LOG"
#endif

#define gridcen         25   /* Center of "grid" used while drawing gates */

#define charheight      8   /* Height of text characters */

#define tapdelay        30  /* How long to wait before a "tap" becomes a "press" */
#define taptolerance    5   /* How far you can move before a "tap" becomes a "press" */
#define knobwait        25   /* How long to wait for the knob during scroll */

#define deffastmin      2   /* Simulator delay for good response (csecs) */
#define deffastmax      50   /* Simulator delay for fast simulation */
#define deffastrate     35   /* Centiseconds per increase in fastspeed */

#define frytime         50   /* How long a frying object fries, in csecs */

#define chrplain        128
#define chrinverse      129
#define chrunderl       132

#define chrgreen        136
#define chryellow       137
#define chrblack        138
#define chrred          139
#define chrcyan         140
#define chrwhite        141
#define chrblue         142
#define chrpurple       143

#define EXEC            "\003"   /* ASCII code of EXECUTE key */
#define CTRLD           "\253"   /* Control-D */


#define maxmaxkinds     255   /* Maximum number of gates in catalog */

#define maxgatesfiles   15
#define defmaxsignal    500   /* Maximum number of TO/FROM nodes */
#define defhtmaxcount   500   /* Maximum number of history timesteps */

#define origin          16384   /* Origin of grid coordinate system */

#define topmessagepos   2   /* Position of first message */

#define maxrots         8   /* Number of gate orientations */

#define hscrollspd      2   /* Knob-scrolling speed */
#define vscrollspd      2
#define hfastscrollspd  10   /* Menu-box-scrolling speed */
#define vfastscrollspd  10

#define watchdogtime    500   /* Time limit for CLR I/O "watchdog" timer */

#define refrdelay       70   /* Delay before refreshing screen */

#define baselinewidth   80
#define kindgroupmaxsize  40   /* Stuff about gate slots in menu area */

#define kindgroupspacing  (gridcen * 2)

#define maxsafescale    (gridcen / log_scale0)

#define menux1          1
#define menux2          48
#define menux3          (-69)
#define menux4          (-27)

#define pigsfly         false   /*  */

#define gattrrecsize    (sizeof(log_gattrrec) + ((sizeof(log_gattrrec)) & 1))
#define kattrrecsize    (sizeof(log_kattrrec) + ((sizeof(log_kattrrec)) & 1))

#define histleft        40
#define histvscale      6
/*(histdown div 24) * 2*/
#define histdivision    30

#define histsweeptype   1
#define histtrigsig     2
#define histstarttime   3
#define histstoptime    4
#define histfullaction  5
#define histminstep     6
#define histmaxstep     7
#define histmaxcount    8
#define histcurcount    9
#define histalignsigs   10
#define histfirsttime   11
#define histcurtime     12
#define histsecdiv      13
#define histcurtstep    14

#define histsweep_contin  0
#define histsweep_onreset  1
#define histsweep_trig  2
#define histsweep_manual  3

#define rablistsize     23   /* Size of Rabbit State Machine */
#define rabtabsize      10   /* Maximum number of rabbits on screen */
#define rabmussize      32   /* Length of rabbit theme music */
#define rabdelay        30000   /* Time to wait for rabbit: 5 Minutes */

#define NAMEGAP         (3 * gg.scale) /* signallabel horizontal offset */

#define maxeditmodes    4

#endif
