#include "attrs.h"
#include "settings.h"
#include <utils/strings.h>

void newattrs(log_gattrrec **gattr, short numattrs, log_kattrrec *kattr)
{
	short i;

	*gattr = (log_gattrrec *)Malloc(numattrs * gattrrecsize);
	for (i = 0; i < numattrs; i++)
	{
		switch (kattr[i].dtype)
		{

			case 'R':
			case 'U':
			case 'F':
				(*gattr)[i].UU.r = kattr[i].UU.U82.r;
				break;

			case 'I':
			case 'H':
				(*gattr)[i].UU.U73.i1 = kattr[i].UU.U73.i1;
				break;

			case 'C':
				(*gattr)[i].UU.c = (char *)Malloc(kattr[i].prec + 1L);
				strcpy((*gattr)[i].UU.c, kattr[i].UU.c);
				break;

			case 'A':
				(*gattr)[i].UU.sp = strdup(kattr[i].UU.sp);
				break;

			case 'B':
				(*gattr)[i].UU.b = kattr[i].UU.b;
				break;

			case 'V':
				(*gattr)[i].UU.nv = kattr[i].UU.U86.dv;
				break;
		}

		(*gattr)[i].blnk = kattr[i].blnk;
		(*gattr)[i].changed = false;
	}
}


void disposeattrs(log_gattrrec **gattr, short numattrs, log_kattrrec *kattr)
{
	short i;

	for (i = 0; i < numattrs; i++)
	{
		switch (kattr[i].dtype)
		{

			case 'C':
				Free((*gattr)[i].UU.c);
				break;

			case 'A':
				strdispose(&(*gattr)[i].UU.sp);
				break;
		}
	}
	Free(*gattr);
}


void copyattrs(log_gattrrec **gattr, log_gattrrec *oldattr, short numattrs, log_kattrrec *kattr)
{
	short i;

	*gattr = (log_gattrrec *)Malloc(numattrs * gattrrecsize);
	for (i = 0; i < numattrs; i++)
	{
		(*gattr)[i] = oldattr[i];
		switch (kattr[i].dtype)
		{

			case 'C':
				(*gattr)[i].UU.c = (char *)Malloc(kattr[i].prec + 1L);
				strcpy((*gattr)[i].UU.c, oldattr[i].UU.c);
				break;

			case 'A':
				(*gattr)[i].UU.sp = strdup(oldattr[i].UU.sp);
				break;
		}
	}
}


