#define NEWKBD_G

#include <utils/p2c.h>

#ifndef NEWCRT_H
#include <graphics/newcrt.h>
#endif

#ifndef NEWKBD_H
#include <graphics/newkbd.h>
#endif

#ifndef MYLIB_H
#include <graphics/mylib.h>
#endif

#include <X11/Xlib.h>

static char *KeyNames[] = {
  "0",
  "1",
  "2",
  "3",
  "4",
  "5",
  "6",
  "7",
  "BackSpace",
  "Tab",
  "Linefeed",
  "Clear",
  "12",
  "Return",
  "13",
  "14",
  "15",
  "16",
  "17",
  "18",
  "Pause",
  "20",
  "21",
  "22",
  "23",
  "24",
  "25",
  "26",
  "Escape",
  "28",
  "29",
  "30",
  "31",
  "space",
  "exclam",
  "quotedbl",
  "numbersign",
  "dollar",
  "percent",
  "ampersand",
  "quoteright",
  "parenleft",
  "parenright",
  "asterisk",
  "plus",
  "comma",
  "minus",
  "period",
  "slash",
  "0",
  "1",
  "2",
  "3",
  "4",
  "5",
  "6",
  "7",
  "8",
  "9",
  "colon",
  "semicolon",
  "less",
  "equal",
  "greater",
  "question",
  "at",
  "A",
  "B",
  "C",
  "D",
  "E",
  "F",
  "G",
  "H",
  "I",
  "J",
  "K",
  "L",
  "M",
  "N",
  "O",
  "P",
  "Q",
  "R",
  "S",
  "T",
  "U",
  "V",
  "W",
  "X",
  "Y",
  "Z",
  "bracketleft",
  "backslash",
  "bracketright",
  "asciicircum",
  "underscore",
  "quoteleft",
  "a",
  "b",
  "c",
  "d",
  "e",
  "f",
  "g",
  "h",
  "i",
  "j",
  "k",
  "l",
  "m",
  "n",
  "o",
  "p",
  "q",
  "r",
  "s",
  "t",
  "u",
  "v",
  "w",
  "x",
  "y",
  "z",
  "braceleft",
  "bar",
  "braceright",
  "asciitilde",
};

void nk_ungetkey(uchar c)
{
  XEvent event;
  char buf[2];

  event.type = KeyPress;
  event.xkey.display = m_display;
  event.xkey.window = m_window;
  buf[0] = c;
  buf[1] = '\0';
  event.xkey.keycode = XKeysymToKeycode(m_display, XStringToKeysym(buf));
  XPutBackEvent(m_display, &event);
}

void nk_keybufclear()
{
  XEvent event;

  while (XCheckTypedEvent(m_display, KeyPress, &event)) {
		// noop
	}
}
	 

void nk_settransarray(int mode, nk_keytransinfo ** mat)
{
  static int dummy;

  if (mode == nk_ktsupplied) {
    /* ignore it for now! */
  } else {
    *mat = (nk_keytransinfo *)(&dummy);
  }
}

